config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'home#index'
  resources :locations
  resources :groups
  resources :meetings do
    resources :messages
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/appointment.rb
class Appointment < ApplicationRecord
  belongs_to :meeting
  belongs_to :location
end

app/models/group.rb
class Group < ApplicationRecord
  validates_presence_of :title
  has_many :memberships
  has_many :users, through: :memberships
  has_many :groups_meetings
  has_many :meetings, through: :groups_meetings

  belongs_to :user, foreign_key: :owner_id
end

app/models/groups_meeting.rb
class GroupsMeeting < ApplicationRecord
  belongs_to :group
  belongs_to :meeting
end

app/models/location.rb
# Location
class Location < ApplicationRecord
  validates_presence_of :title
  has_many :appointments
  has_many :meetings, through: :appointments
  geocoded_by :address
  reverse_geocoded_by :latitude, :longitude
  after_validation :geocode, :reverse_geocode
end

app/models/meeting.rb
class Meeting < ApplicationRecord
  validates_presence_of :title
  has_many :appointments
  has_many :locations, through: :appointments
  has_many :users_meetings
  has_many :users, through: :users_meetings
  has_many :groups_meetings
  has_many :groups, through: :groups_meetings
  has_many :messages
end

app/models/membership.rb
class Membership < ApplicationRecord
  belongs_to :user
  belongs_to :group
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :meeting
  belongs_to :user
end

app/models/user.rb
# User
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :confirmable

  validates_presence_of :name, :email, :phone

  has_one  :user_profile
  has_many :memberships
  has_many :groups, through: :memberships
  has_many :owned_groups, foreign_key: :owner_id, class_name: 'Group'
  has_many :users_meetings
  has_many :meetings, through: :users_meetings
  has_one_attached :avatar
  has_many :messages

  def avatar_thumbnail
    if avatar.attached?
      avatar.variant(resize: "150x150!").processed
    else
      'default_profile.jpg'
    end
  end
end

app/models/user_profile.rb
class UserProfile < ApplicationRecord
  belongs_to :user
  validates_presence_of :bio
end

app/models/users_meeting.rb
class UsersMeeting < ApplicationRecord
  belongs_to :user
  belongs_to :meeting
end

app/controllers/application_controller.rb
# Main controller
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name, :phone, :avatar])
    devise_parameter_sanitizer.permit(:account_update, keys: [:avatar])
  end
end

app/controllers/groups_controller.rb
# GroupsController
class GroupsController < ApplicationController
  before_action :current_group, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!

  def index
    @groups = Group.all
  end

  def create
    @group = current_user.owned_groups.new(group_params)

    if @group.save
      @group.users = group_members
      redirect_to groups_path, flash: { notice: 'Group was successfully created.' }
    else
      redirect_to groups_path, flash: { error: @group.errors.full_messages.to_sentence }
    end
  end

  def update
    if @group.update(group_params)
      @group.users = group_members
      redirect_to groups_path, flash: { notice: 'Group was successfully updated.' }
    else
      redirect_to edit_group_path, flash: { error: @group.errors.full_messages.to_sentence }
    end
  end

  def destroy
    @group.delete
    redirect_to groups_path, flash: { notice: 'Group was successfully deleted.' }
  end

  private

  def group_params
    params.require(:group).permit(:title, :description)
  end

  def group_members
    User.where(id: params[:group][:users].reject(&:empty?))
  end

  def current_group
    @group = Group.find(params[:id])
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
end

app/controllers/locations_controller.rb
# Location controller
class LocationsController < ApplicationController
  def index
    @locations = Location.all
  end

  def show
    @location = Location.find(params[:id])
  end

  def new
    @location = Location.new
  end

  def create
    @location = Location.new({ title: location_params[:title], address: location_params[:address], latitude: location_params[:latitude], longitude: location_params[:longitude] })
    if @location.save
      redirect_to locations_path, flash: { notice: "Successfully created location." }
    else
      render action: 'new', flash: { error: @location.errors.full_messages.to_sentence }
    end
  end

  def edit
    @location = Location.find(params[:id])
  end

  def update
    @location = Location.find(params[:id])
    if @location.update(location_params)
      redirect_to @location, flash: { notice: "Successfully updated location." }
    else
      render action: 'edit'
    end
  end

  def destroy
    @location = Location.find(params[:id])
    @location.delete
    redirect_to locations_url, flash: { notice: "Successfully destroyed location." }
  end

  private

  def location_params
    params.require(:location).permit(:title, :address, :latitude, :longitude)
  end
end

app/controllers/meetings_controller.rb
# Meetings controller
class MeetingsController < ApplicationController
  before_action :current_meeting, only: [:show, :edit, :update, :destroy]

  def index
    @meetings = Meeting.all
  end

  def create
    @meeting = Meeting.new({ title: meeting_params[:title], description: meeting_params[:description] })

    if @meeting.save
      @meeting.users = meeting_members
      send_invitations
      redirect_to meetings_path, flash: { notice: 'Meeting was successfully created.' }
    else
      redirect_to meetings_path, flash: { error: @meeting.errors.full_messages.to_sentence }
    end
  end

  def update
    if @meeting.update({ title: meeting_params[:title], description: meeting_params[:description] })
      resend_invitations
      @meeting.users = meeting_members
      redirect_to meetings_path, flash: { notice: 'Meeting was successfully updated.' }
    else
      redirect_to edit_meeting_path, flash: { error: @meeting.errors.full_messages.to_sentence }
    end
  end

  def destroy
    @meeting.delete
    redirect_to meetings_path, flash: { notice: 'Meeting was successfully deleted.' }
  end

  private

  def send_invitations
    meeting_members.each do |user|
      UserMailer.with(user: user, meeting: @meeting).meeting_email.deliver_now
    end
  end

  def resend_invitations
    meeting_members.each do |user|
      UserMailer.with(user: user, meeting: @meeting).updated_meeting_email.deliver_now
    end
  end

  def meeting_params
    params.require(:meeting).permit(:title, :description, users: [])
  end

  def meeting_members
    User.where(id: meeting_params[:users].reject(&:empty?))
  end

  def current_meeting
    @meeting = Meeting.find(params[:id])
  end
end

app/controllers/messages_controller.rb
# MessagesController
class MessagesController < ApplicationController
  before_action :set_meeting
  before_action :authenticate_user!

  def create
    message = @meeting.messages.new(message_params)
    message.user = current_user
    message.save
    MessageRelayJob.perform_later(message)
  end

  private

  def set_meeting
    @meeting = Meeting.find(params[:meeting_id])
  end

  def message_params
    params.require(:message).permit(:body)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def bootstrap_class_for_flash(flash_type)
    cases = {
      'success' => 'alert-success',
      'error' => 'alert-danger',
      'alert' => 'alert-warning',
      'notice' => 'alert-info'
    }
    cases[flash_type]
  end
end

app/helpers/groups_helper.rb
# List for selecting group members
module GroupsHelper
  def users_select_list
    User.all.collect { |u| [u.email, u.id] }
  end
end

app/helpers/meetings_helper.rb
# List for selecting meeting members
module MeetingsHelper
  def users_select_list
    User.all.collect { |u| [u.email, u.id] }
  end

  def groups_select_list
    Group.all.collect { |g| [g.title, g.id] }
  end
end

app/views/groups/_form.html.erb
<div class="form-group">
  <%= f.label :title %><br>
  <%= f.text_area :title, class: 'form-control', rows: 1 %>
</div>
<div class="form-group">
  <%= f.label :description %><br>
  <%= f.text_area :description, class: 'form-control', rows: 3 %>
</div>
<div class="form-group">
  <%= f.label :users %><br>
  <%= f.select :users, options_for_select(users_select_list), {:include_blank => true}, {:multiple => true}  %>
</div>

app/views/groups/edit.html.erb
<div class="col-md-3">
  <h3>Edit group</h3>

  <div id='group_section'>
    <%= form_for :group, url: group_path(@group), html: { method: :put } do |form| %>
      <%= render 'form', f: form %>
      
      <div class="d-flex justify-content-end mt-2">
        <%= form.button :create, type: :submit, class: 'btn btn-info' %>
      </div>
    <% end %>
  </div>
</div>
<div class="col-md-9">
  <% if current_user %>
    <div>
      <h4>List of groups:</h4> <br>
      <div>
        <% current_user.owned_groups.each do |group| %>
          <%= group.title %><br>
          <%= link_to "Show", group %>
          <%= link_to "Edit", edit_group_path(group) %>
          <%= link_to "Destroy", group, method: :delete, data: { confirm: "Are you sure?" } %><hr>
        <% end %>
        </div>
    </div>
  <% end %>
</div>

app/views/groups/index.html.erb
<p>
  <% if current_user %>
    <%= link_to "New group", new_group_path %>
    <div>
      <h4>List of groups:</h4> <br>
      <div>
        <% @groups.each do |group| %>
          <%= group.title %><br>
          <%= link_to "Show", group %>
          <%= link_to "Edit", edit_group_path(group) %>
          <%= link_to "Destroy", group, method: :delete, data: { confirm: "Are you sure?" } %><hr>
        <% end %>
        </div>
    </div>
  <% end %>
</p>

app/views/groups/new.html.erb
<div class="col-md-3">
  <h3>Adding new group</h3>

  <div id='group_section'>
    <%= form_for :group, url: groups_path do |form| %>
      <%= render 'form', f: form %>
      
      <div class="d-flex justify-content-end mt-2">
        <%= form.button :create, type: :submit, class: 'btn btn-info' %>
      </div>
    <% end %>
  </div>
</div>
<div class="col-md-9">
  <% if current_user %>
    <div>
      <h4>List of groups:</h4> <br>
      <div>
        <% current_user.owned_groups.each do |group| %>
          <%= group.title %><br>
          <%= link_to "Show", group %>
          <%= link_to "Edit", edit_group_path(group) %>
          <%= link_to "Destroy", group, method: :delete, data: { confirm: "Are you sure?" } %><hr>
        <% end %>
        </div>
    </div>
  <% end %>
</div>

app/views/groups/show.html.erb
<div>
  <h2><%= @group.title %></h2><br>
  <p>
    <%= @group.description %><br>
  </p>
</div>

app/views/home/index.html.erb
<div class="col-md-3">
  <p>
    <% if current_user %>
      <p>
        Hi <%= image_tag(current_user.avatar_thumbnail, size: "30x30") %> <%= current_user.name %><br>
      </p>
      <p>
        <%= link_to "Edit Account", edit_user_registration_path %>
      </p>
      <p>
        <%= link_to "New Group", new_group_path %>
      </p>
      <p>
        <%= link_to "New Meeting", new_meeting_path %>
      </p>
      <br />
      
    <% else %>
      <p>
        Please, <%= link_to "Log In", new_user_session_path %> or <%= link_to "Sign Up", new_user_registration_path %>!
      </p>
    <% end %>
  </p>
</div>
<div class="col-md-9">
  <% if current_user %>
    <h3>Meetings:</h3>
    <div>
      <% Meeting.all.each do |meeting| %>
        <%= meeting.title %><br>
        <%= link_to "Show", meeting %>
        <%= link_to "Edit", edit_meeting_path(meeting) %>
        <%= link_to "Destroy", meeting, method: :delete, data: { confirm: "Are you sure?" } %><hr>
      <% end %>
    </div>
  <% end %>
</div>

app/views/layouts/_flash.html.erb
<div class="container">
  <% flash.each do |type, msg| %>
    <div class="alert <%= bootstrap_class_for_flash(type) %> alert-dismissable">
      <%= msg %>
      <button class="close" data-dismiss="alert">x</button>
    </div>
  <% end %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MeetAndEat</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <nav class="navbar sticky-top navbar-expand-lg navbar-dark bg-primary">
      <a class="navbar-brand" href="/">MeetAndEat</a>

      <div class="collapse navbar-collapse d-flex justify-content-center">
        <div class="navbar-nav">
          <a class="nav-item nav-link active" href="/">Home</a>

          <% if current_user %>
            <%= link_to "Log Out", destroy_user_session_path, method: :delete, class: 'nav-item nav-link active' %>
          <% else %>
            <%= link_to "Log In", new_user_session_path, class: 'nav-item nav-link active' %>
            <%= link_to "Sign Up", new_user_registration_path, class: 'nav-item nav-link active' %>
          <% end %>
        </div>
      </div>
    </nav>

    <div class="container mt-2">
      <%= render partial: 'layouts/flash', flash: flash %>
    </div>

    <div class="container mt-5">
      <div class="row">
        <%= yield %>
      </div>
    </div>
  </body>
</html>

app/views/locations/_form.html.erb
<div class="col-md-12">
  <%= form_with(model: [@location], data: { controler: "places" }) do |f| %>
  <p>
    <%= f.label :address %><br />
    <%= f.search_field :address, data: { target: "places.field" } %>
  </p>
  <div id="map" data-target="places.map" style="height:400px"></div>
  <p><%= f.submit %></p>
<% end %>
</div>

<!-- Async script executes immediately and must be after any DOM elements used in callback. -->
<script
  src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCjrMKnoV-aDipFL8--d5o3B916Qkm61Yk&callback=initAutocomplete&libraries=places&v=weekly"
  async
></script>

<script>
  function initAutocomplete() {
    const map = new google.maps.Map(document.getElementById("map"), {
      center: { lat: 49.8326046, lng: 23.8721529 },
      zoom: 13,
      mapTypeId: "roadmap",
    });
    // Create the search box and link it to the UI element.
    const input = document.getElementById("location_address");
    const searchBox = new google.maps.places.SearchBox(input);
    map.controls[google.maps.ControlPosition.TOP_LEFT].push(input);
    // Bias the SearchBox results towards current map's viewport.
    map.addListener("bounds_changed", () => {
      searchBox.setBounds(map.getBounds());
    });
    let markers = [];
    // Listen for the event fired when the user selects a prediction and retrieve
    // more details for that place.
    searchBox.addListener("places_changed", () => {
      const places = searchBox.getPlaces();

      if (places.length == 0) {
        return;
      }
      // Clear out the old markers.
      markers.forEach((marker) => {
        marker.setMap(null);
      });
      markers = [];
      // For each place, get the icon, name and location.
      const bounds = new google.maps.LatLngBounds();
      places.forEach((place) => {
        if (!place.geometry || !place.geometry.location) {
          console.log("Returned place contains no geometry");
          return;
        }
        const icon = {
          url: place.icon,
          size: new google.maps.Size(71, 71),
          origin: new google.maps.Point(0, 0),
          anchor: new google.maps.Point(17, 34),
          scaledSize: new google.maps.Size(25, 25),
        };
        // Create a marker for each place.
        markers.push(
          new google.maps.Marker({
            map,
            icon,
            title: place.name,
            position: place.geometry.location,
          })
        );

        if (place.geometry.viewport) {
          // Only geocodes have viewport.
          bounds.union(place.geometry.viewport);
        } else {
          bounds.extend(place.geometry.location);
        }
      });
      map.fitBounds(bounds);
    });
  }
</script>

app/views/locations/edit.html.erb
<h3>"Edit Location" </h3>
<%= render 'form' %>

<p>
  <%= link_to "Show", @location %> |
  <%= link_to "View All", locations_path %>
</p>

app/views/locations/index.html.erb
<% "Locations" %>

<table>
  <tr>
    <th>Title</th>
    <th>Address</th>
    <th>Latitude</th>
    <th>Longitude</th>
  </tr>
  <% for location in @locations %>
    <tr>
      <td><%= location.title %></td>
      <td><%= location.address %></td>
      <td><%= location.latitude %></td>
      <td><%= location.longitude %></td>
      <td><%= link_to "Show", location %></td>
      <td><%= link_to "Edit", edit_location_path(location) %></td>
      <td><%= link_to "Destroy" %></td>
    </tr>
  <% end %>
</table>

<p><%= link_to "New Location", new_location_path %></p>

app/views/locations/new.html.erb
<h3>Adding New location</h3>

<%= render 'form' %>

<p><%= link_to "Back to List", locations_path %></p>

app/views/locations/show.html.erb
<p>
  <strong>Title:</strong>
  <%= @location.title %><br>
</p>
<p>
  <strong>Address:</strong>
  <%= @location.address %>
</p>
<p>
  <strong>Latitude:</strong>
  <%= @location.latitude %>
</p>
<p>
  <strong>Longitude:</strong>
  <%= @location.longitude %>
</p>

<p>
  <%= link_to "Edit", edit_location_path(@location) %> |
  <%= link_to "Destroy", @location %> |
  <%= link_to "View All", locations_path %>
</p>

app/views/meetings/_form.html.erb
<div class="form-meeting">
  <%= f.label :title %><br>
  <%= f.text_field :title, class: 'form-control', rows: 1 %>
</div>
<div class="form-meeting">
  <%= f.label :description %><br>
  <%= f.text_area :description, class: 'form-control', rows: 3 %>
</div>
<div class="form-meeting">
  <%= f.label :users %><br>
  <%= f.select :users, options_for_select(users_select_list), {:include_blank => true}, {:multiple => true}  %>
</div>
<div class="form-meeting">
  <%= f.label :groups %><br>
  <%= f.select :groups, options_for_select(groups_select_list), {:include_blank => true}, {:multiple => true}  %>
</div>

app/views/meetings/edit.html.erb
<div class="col-md-3">
  <h3>Edit meeting</h3>

  <div id='meeting_section'>
    <%= form_for :meeting, url: meeting_path(@meeting), html: { method: :put } do |f| %>
      <%= render 'form', f: f %>
      
      <div class="d-flex justify-content-end mt-2">
        <%= f.button :create, type: :submit, class: 'btn btn-info' %>
      </div>
    <% end %>
  </div>
</div>
<div class="col-md-9">
  <% if current_user %>
    <div>
      <h4>List of meetings:</h4> <br>
      <div>
        <% Meeting.all.each do |meeting| %>
          <%= meeting.title %><br>
          <%= link_to "Show", meeting %>
          <%= link_to "Edit", edit_meeting_path(meeting) %>
          <%= link_to "Destroy", meeting, method: :delete, data: { confirm: "Are you sure?" } %><hr>
        <% end %>
        </div>
    </div>
  <% end %>
</div>

app/views/meetings/index.html.erb
<p>
  <% if current_user %>
    <%= link_to "New meeting", new_meeting_path %>
    <div>
      <h3>Meetings:</h3> <br>
      <div>
        <% @meetings.each do |meeting| %>
          <%= meeting.title %><br>
          <%= link_to "Show", meeting %>
          <%= link_to "Edit", edit_meeting_path(meeting) %>
          <%= link_to "Destroy", meeting, method: :delete, data: { confirm: "Are you sure?" } %><hr>
        <% end %>
      </div>
    </div>
  <% end %>
</p>

app/views/meetings/new.html.erb
<div class="col-md-3">
  <h3>Adding new meeting</h3>

  <div id='meeting_section'>
    <%= form_for :meeting, url: meetings_path do |form| %>
      <%= render 'form', f: form %>
      
      <div class="d-flex justify-content-end mt-2">
        <%= form.button :create, type: :submit, class: 'btn btn-info' %>
      </div>
    <% end %>
  </div>
</div>
<div class="col-md-9">
  <% if current_user %>
    <div>
      <h4>List of meetings:</h4> <br>
      <div>
        <% Meeting.all.each do |meeting| %>
          <%= meeting.title %><br>
          <%= link_to "Show", meeting %>
          <%= link_to "Edit", edit_meeting_path(meeting) %>
          <%= link_to "Destroy", meeting, method: :delete, data: { confirm: "Are you sure?" } %><hr>
        <% end %>
        </div>
    </div>
  <% end %>
</div>

app/views/meetings/show.html.erb
<div class="col-md-3">
  <div>
    <h2><%= @meeting.title %></h2>
    <p><%= @meeting.description %></p>
    <p><%= 'Locations' %></p>
  </div>
  <table>
    <tr>
      <th>Title</th>
      <th>Address</th>
    </tr>
    <% for location in Location.all %>
      <tr>
        <td><%= location.title %></td>
        <td><%= location.address %></td>
      </tr>
    <% end %>
  </table>
</div>
<div class="col-md-9">
  <div class="meeting_chat">
    <h3>Meeting chat:</h3>

    <div data-behavior='messages' data-meeting-id='<%= @meeting.id %>'>
      <% @meeting.messages.last(10).each do |message| %>
        <%= render message %>
      <% end %>
    </div>

    <div class="new_messages">
      <smal>new message:</smal>
      <%= form_for [@meeting, Message.new], remote: true do |f| %>
        <div class="field">
          <%= f.text_area :body, rows: 1, class: 'form-control', autofocus: true %>
        </div>

        <div class="actions">
          <%= f.submit "Send", class: 'btn btn-primary' %>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/messages/_message.html.erb
<div>
  <strong><%= message.user.name %>:</strong><%= message.body %>
</div>

app/views/messages/create.js.erb
$("#new_message")[0].reset()